#include <iostream>

using namespace std;

int main()
{
    int n, q;
    cin>>n>>q;
    float Direktan_napad[n], Otrovan_napad[n], Hp[q];
    for(int i=0;i<n;i++)
    {
        cin>>Direktan_napad[i]>>Otrovan_napad[i];
    }
    for(int i=0;i<q;i++)
    {
        cin>>Hp[i];
    }
    for(int i=0;i<q;i++)
    {
        float otrov_po_potezu=0, s=0, hp_tren=Hp[i];
        int potezi=0;
        while(hp_tren>0&&potezi<n)
        {
            if(Direktan_napad[potezi]>Otrovan_napad[potezi])
                hp_tren-=Direktan_napad[potezi];
            else
            {
                otrov_po_potezu+=Otrovan_napad[potezi];
                hp_tren-=otrov_po_potezu;
            }
        }
        if(Hp[i]>0)
            cout<<-1<<endl;
        else
            cout<<potezi<<endl;
    }
    return 0;
}